Overview
-----------

This interface layer handles the communication between `IBM WXS Catalog` and `IBM WXS Container` or `IBM WXS Catalog` and `IBM WXS Client` charms.
The provider end of this interface provides the WXS Catalog service. The consumer/Requires part will be the IBM WXS Container and IBM WXS Client, which want the IBM WXS Catalog Server Ip Address and Port information to fetch the Data Grid.


Usage
------

#### Provides
IBM WXS catalog Server product will provide this interface. This interface layer will set the following states, as appropriate:

 - `{relation_name}.available`: The relation is established, IBM WXS Catalog is ready to send it's Ip Address and Port information. At this point, the charm waits for Provider charm to send IP Address and port.
	- `set_wxs_catalog_details()` : Sets IP Address and Port of the Catalog Server once the Server started successfully.

#### Requires

Consumer charms `IBM WXS Container` and `IBM WXS Client` will require this interface to connect to WXS Catalog so that they can connect to Catalog Server. 
This interface layer will set the following states, as appropriate:

- `{relation_name}.available` : The consumer charm has been related to a IBM WXS Catalog provider charm. 
- `{relation_name}.ready` : IBM WXS Container or IBM WXS Client is now ready to connect to WXS Catalog to fetch Data Grid. 
	The Http Server charm can access the configuration details using the below methods:

    - `get_wxs_catalog_port()` - returns the port of the Catalog Server that listens.
    - `get_wxs_catalog_ip()` - returns running ip of the Catalog Server.
   
