from charms.reactive import hook
from charms.reactive import RelationBase
from charms.reactive import scopes


class WXSProvides(RelationBase):
    # Every unit connecting will get the same information
    scope = scopes.SERVICE
    # convenient way to provide accessor methods
    # auto_accessors = ['wxs_catalog_ip', 'wxs_catalog_port']

    @hook('{provides:ibm-wxs}-relation-joined')
    def joined(self):
        conversation = self.conversation()
        conversation.set_state('{relation_name}.available')
        print("In joined hook in ibm-wxs interface")

    @hook('{provides:ibm-wxs}-relation-changed')
    def changed(self):
        conversation = self.conversation()
        conversation.set_state('{relation_name}.available')
        print("In changed hook in ibm-wxs interface")

    @hook('{provides:ibm-wxs}-relation-departed')
    def departed(self):
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.available')
        print("In departed hook in ibm-wxs interface")

    def dismiss(self, service):
        conversation = self.conversation(service)
        conversation.remove_state('{relation_name}.available')
        print("In dismissed for service", service)

    def reset_states(self, service):
        conversation = self.conversation(service)
        conversation.remove_state('{relation_name}.available')

    def set_wxs_catalog_details(self, service, wxs_catalog_ip,
                                wxs_catalog_port):
        conversation = self.conversation(service)
        print("In set_wxs_catalog_details for service", service)
        conversation.set_remote(data={
            'wxs_catalog_ip': wxs_catalog_ip,
            'wxs_catalog_port': wxs_catalog_port
        })

    #    def wxs_catalog_ip(self):
    #    """
    #    Return a list of services requesting databases.
    #    """
    #    wxs_catalog_ip = []
    #    for conversation in self.conversations():
    #        wxs_catalog_ip.append(conversation.scope)
    #    return wxs_catalog_ip
#
#    def wxs_catalog_port(self):
#        """
#        Return a list of services requesting databases.
#        """
#        wxs_catalog_port = []
#        for conversation in self.conversations():
#            wxs_catalog_port.append(conversation.scope)
#        return wxs_catalog_port

    def services(self):
        """
        Return a list of services requesting Catalog.
        """
        service = []
        for conversation in self.conversations():
            service.append(conversation.scope)
        return service
