# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# from charmhelpers.core import hookenv
from charms.reactive import hook
from charms.reactive import RelationBase
from charms.reactive import scopes


class WXSRequires(RelationBase):
    scope = scopes.GLOBAL

    auto_accessors = ['wxs_catalog_ip', 'wxs_catalog_port']

    @hook('{requires:ibm-wxs}-relation-joined')
    def joined(self):
        self.set_state('{relation_name}.available')

    @hook('{requires:ibm-wxs}-relation-changed')
    def changed(self):
        print("Status is ibm-wxs.available in requires")
        if str(self.get_remote('wxs_catalog_port')) != "None":
            self.set_state('{relation_name}.ready')
            print("Status is relation_name.available in requires")

    @hook('{requires:ibm-wxs}-relation-departed')
    def departed(self):
        self.remove_state('{relation_name}.available')
        self.remove_state('{relation_name}.ready')

    def get_wxs_catalog_port(self):
        return self.get_remote('wxs_catalog_port')

    def get_wxs_catalog_ip(self):
        return self.get_remote('wxs_catalog_ip')
