from charms.reactive import hook
from charms.reactive import RelationBase
from charms.reactive import scopes


class wasdmProvides(RelationBase):
    # Every unit connecting will get the same information
    scope = scopes.GLOBAL

    @hook('{provides:was-nd}-relation-{joined}')
    def joined(self):
        conversation = self.conversation()
        conversation.set_state('{relation_name}.connected')
        conversation.remove_state('{relation_name}.departed')

    @hook('{provides:was-nd}-relation-{broken}')
    def broken(self):
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.connected')
        conversation.set_state('{relation_name}.available')
        conversation.set_state('{relation_name}.departed')

    def dismiss(self):
        for conv in self.conversations():
            conv.remove_state('{relation_name}.departed')

    def reset_states(self, service):
        conversation = self.conversation(service)
        conversation.remove_state('{relation_name}.connected')
        conversation.remove_state('{relation_name}.departed')

    def set_was_dm_details(self, hostname, dminstallpath,
                           profilename, dmgruser, dmgrpwd):
        for conversation in self.conversations():
            conversation.set_remote(data={
                                          'hostname': hostname,
                                          'dminstallpath': dminstallpath,
                                          'profilename': profilename,
                                          'dmgruser': dmgruser,
                                          'dmgrpwd': dmgrpwd})

    def services(self):
        """
        Return a list of services connecting to WASND.
        """
        service = []
        for conversation in self.conversations():
            service.append(conversation.scope)
        return service
